; script-fu-guide-grid
; James Martin
; Created: 20020801
; Tested under GIMP 1.2.3 for win32

; Draws a grid of guides. The grid's x and y spacing may be specified
; by the end-user.

; This is my first script-fu script so I've no doubt overlooked
; something! :-)

; It was inspired by the GIMP-Perl guide-grid script and should be
; useful for win32 Gimpers who can't [be bothered to] get Perl working
; under win32.  New schemers like me may like to use it as an example
; script too as it's pretty simple.

; the grid spacing defaults can easily be changed by changing the
; "16"s at the bottom of the script.

(define (script-fu-guide-grid img drawable spacingx spacingy) 
  (gimp-undo-push-group-start img)
  (let* 
      ((width (car (gimp-drawable-width drawable)))
       (height(car (gimp-drawable-height drawable))))
    (set! y spacingy)
    (while (< y height)
	   (gimp-image-add-hguide img y)
	   (set! y (+ y spacingy))
	   )
    
    (set! x spacingx)
    (while (< x width)
	   (gimp-image-add-vguide img x)
	   (set! x (+ x spacingx))
	   )
    ) ; let
      
  (gimp-undo-push-group-end img) 
    
  (gimp-displays-flush)
)
    
(script-fu-register "script-fu-guide-grid" 
   		    "<Image>/Script-Fu/Utils/Grid of Guides" 
   		    "Create a grid of guides" 
   		    "James Martin <drseuk@sdf-eu.org>" 
   		    "James Martin" 
   		    "20020801" 
   		    "RGB*, GRAY*, INDEXED*" 
   		    SF-IMAGE "Input Image" 0 
   		    SF-DRAWABLE "Input Drawable" 0
		    SF-VALUE "Grid x spacing" "16"
		    SF-VALUE "Grid y spacing" "16"
		    )
